--- gdm-2.30.4/gui/simple-greeter/gdm-user-manager.c.ori	2010-07-20 03:31:59.111785942 +0100
+++ gdm-2.30.4/gui/simple-greeter/gdm-user-manager.c	2010-07-20 03:32:13.747579170 +0100
@@ -93,7 +93,7 @@
         union {
                 DBusGProxyCall      *get_current_session_call;
                 DBusGProxyCall      *get_seat_id_call;
-        };
+        } proxy_call;
 
         DBusGProxy                  *proxy;
 } GdmUserManagerSeat;
@@ -116,7 +116,7 @@
         union {
                 DBusGProxyCall          *get_unix_user_call;
                 DBusGProxyCall          *get_x11_display_call;
-        };
+        } proxy_call;
 
         DBusGProxy                      *proxy;
 
@@ -542,7 +542,7 @@
         char           *seat_id;
         gboolean        res;
 
-        g_assert (manager->priv->seat.get_seat_id_call == call);
+        g_assert (manager->priv->seat.proxy_call.get_seat_id_call == call);
 
         error = NULL;
         seat_id = NULL;
@@ -552,7 +552,7 @@
                                      DBUS_TYPE_G_OBJECT_PATH,
                                      &seat_id,
                                      G_TYPE_INVALID);
-        manager->priv->seat.get_seat_id_call = NULL;
+        manager->priv->seat.proxy_call.get_seat_id_call = NULL;
         g_object_unref (proxy);
 
         if (! res) {
@@ -604,7 +604,7 @@
                 goto failed;
         }
 
-        manager->priv->seat.get_seat_id_call = call;
+        manager->priv->seat.proxy_call.get_seat_id_call = call;
 
         return;
 
@@ -742,7 +742,7 @@
         char           *session_id;
         gboolean        res;
 
-        g_assert (manager->priv->seat.get_current_session_call == call);
+        g_assert (manager->priv->seat.proxy_call.get_current_session_call == call);
         g_assert (manager->priv->seat.state == GDM_USER_MANAGER_SEAT_STATE_GET_SESSION_ID);
 
         error = NULL;
@@ -753,7 +753,7 @@
                                      DBUS_TYPE_G_OBJECT_PATH,
                                      &session_id,
                                      G_TYPE_INVALID);
-        manager->priv->seat.get_current_session_call = NULL;
+        manager->priv->seat.proxy_call.get_current_session_call = NULL;
         g_object_unref (proxy);
 
         if (! res) {
@@ -801,7 +801,7 @@
                 goto failed;
         }
 
-        manager->priv->seat.get_current_session_call = call;
+        manager->priv->seat.proxy_call.get_current_session_call = call;
 
         return;
 
@@ -870,7 +870,7 @@
 
         manager = new_session->manager;
 
-        g_assert (new_session->get_unix_user_call == call);
+        g_assert (new_session->proxy_call.get_unix_user_call == call);
 
         error = NULL;
         uid = (guint) -1;
@@ -879,7 +879,7 @@
                                      &error,
                                      G_TYPE_UINT, &uid,
                                      G_TYPE_INVALID);
-        new_session->get_unix_user_call = NULL;
+        new_session->proxy_call.get_unix_user_call = NULL;
 
         if (! res) {
                 if (error != NULL) {
@@ -922,7 +922,7 @@
                 goto failed;
         }
 
-        new_session->get_unix_user_call = call;
+        new_session->proxy_call.get_unix_user_call = call;
         return;
 
 failed:
@@ -938,7 +938,7 @@
         char     *x11_display;
         gboolean  res;
 
-        g_assert (new_session->get_x11_display_call == call);
+        g_assert (new_session->proxy_call.get_x11_display_call == call);
 
         error = NULL;
         x11_display = NULL;
@@ -948,7 +948,7 @@
                                      G_TYPE_STRING,
                                      &x11_display,
                                      G_TYPE_INVALID);
-        new_session->get_x11_display_call = NULL;
+        new_session->proxy_call.get_x11_display_call = NULL;
 
         if (! res) {
                 if (error != NULL) {
@@ -991,7 +991,7 @@
                 goto failed;
         }
 
-        new_session->get_x11_display_call = call;
+        new_session->proxy_call.get_x11_display_call = call;
         return;
 
 failed: